#ifndef include_cvviewer
#define include_cvviewer

/*****************************************************************************

**    **   **
**    **    **
**    **     **
********      **     $RCSfile: cvviewer.h,v $
**    **     **
**    **    **
**    **   **

Author:  Jon Goldman
Date:    

Modification Date:  $Date: 1995/07/21 00:31:22 $

Description:

Revisions:

  Date		Who	Description
  ----     	---   	-----------

*/

/***** include files *****/
#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoSpotLight.h>
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/SbBox.h>
#include <Inventor/actions/SoGetBoundingBoxAction.h>

#include "interface.h"
#include "mode.h"

/***** macros or const *****/

#ifndef ON
#define ON 1
#endif

#ifndef OFF
#define OFF 0
#endif

/***** function prototypes *****/

/***** data structures or classes *****/

class DatabaseList
{
  public:
    // Constructors
    DatabaseList(char *filename);

    // Destructor

    // other member functions

    // Accessor functions

    // static class members

    SoSeparator		*root;
    SbBox3f		bbox;
    
    DatabaseList	*next;

  protected:
      
  private:

  // friend functions or classes
};

class CvViewer
{
  public:
    // Constructors
    CvViewer(int argc, char *argv[]);

    // Destructor

    // other member functions

    // Accessor functions

    // static class members
    int			numFiles;
    DatabaseList	*database;
    SoPointLight	*pointLight;
    SoSpotLight		*spotLight;
    SoTransform		*myTrans;
    SoRotation		*navRot;
    CaveInterface	*interface;
    Mode		*mode;
    
    static float globalT[3];
    static float globalMin[3],globalMax[3];
    static float TRANS_FACTOR;

  protected:
      
  private:

  // friend functions or classes
};


inline float MIN(float a,float b)
{
    return (a<b ? a : b);
}

inline float MAX(float a,float b)
{
    return (a>b ? a : b);
}


#endif	/* include_cvviewer */
