/*****************************************************************************

File: $RCSfile: ivdraw.C,v $

	By:	Jon Goldman
	
	Date:
	
Modification Date:  $Date: 1995/07/21 00:31:22 $
	
Description:

Revisions:


*****************************************************************************/

/***** include files *****/
#include <math.h>

#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSpotLight.h>
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <iostream.h>

// necessary X stuff
#include <X11/Xlib.h>

#include <cave.h>

#include "cvviewer.h"

/***** macros or const (c++) *****/
//const DEG_TO_RAD=M_PI/180.0;


/***** function prototypes *****/

/***** typedefs or classes (c++) *****/

/***** storage *****/

// from cave library
extern Display         *CAVEXdisplay;
extern Window          CAVEglxWindow;

extern CvViewer *cvviewer;
extern XWindowAttributes	winAtts;
extern CvViewer *cvviewer;

/**********************************************************************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
**************************************** Start of code ****************************************
***********************************************************************************************/

//
// The CAVE frame function handles user interface stuff -- but we only need to call it once
// per frame, that's why all this code sits here
//
void InventorFrameFunction()
{
    static float transX=0.0,transY=0.0,transZ=0.0;
    static float scaleX=1.0,scaleY=1.0,scaleZ=1.0;
    static float scaleDown=0.980;
    static float scaleUp=1.0/scaleDown;

    // Wand control to major tom, wand control to major tom....
    // get current wand state
    cvviewer->interface->wand->WandControl();

    // spot light points with the wand
    cvviewer->spotLight->location.setValue(cvviewer->interface->wand->wandX,
					   cvviewer->interface->wand->wandY,
					   cvviewer->interface->wand->wandZ);
    cvviewer->spotLight->direction.setValue(cvviewer->interface->wand->wandVect);

    if (cvviewer->interface->wand->ButtonPressed(3))
      {
	  //cerr << "Process:  button 3 pressed" << endl;
	  cvviewer->mode->Bump();
      }

    switch (cvviewer->mode->CurMode())
      {
	case 0:		// NAV ONLY
	  if (cvviewer->interface->wand->ButtonOn(2))
	    {
		//cout << "CAVEBUTTON2 only, adding to translation " << endl;
		transX -= CvViewer::TRANS_FACTOR*cvviewer->interface->wand->wandVect[0];
		transY -= CvViewer::TRANS_FACTOR*cvviewer->interface->wand->wandVect[1];
		transZ -= CvViewer::TRANS_FACTOR*cvviewer->interface->wand->wandVect[2];
	    }
	  cvviewer->myTrans->translation.setValue(transX+CvViewer::globalT[0], transY+CvViewer::globalT[1], transZ+CvViewer::globalT[2]);
	  if (cvviewer->interface->wand->ButtonPressed(1))
	    {
		// reset
		transX=transY=transZ=0.0;
	    }
	  break;

	case 1:		// Datasets
	  if (cvviewer->interface->wand->ButtonPressed(1))
	    {
		cvviewer->mode->FileMaskDown();
	    }
	  else if (cvviewer->interface->wand->ButtonPressed(2))
	    {
		cvviewer->mode->FileMaskUp();
	    }
	  break;
	  
	case 2:		// Scale
	  if (cvviewer->interface->wand->ButtonOn(1))
	    {
		scaleX *= scaleDown; scaleY *= scaleDown; scaleZ *= scaleDown;
	    }
	  else if (cvviewer->interface->wand->ButtonOn(2))
	    {
		scaleX *= scaleUp; scaleY *= scaleUp; scaleZ *= scaleUp;
	    }

	  if (CAVEBUTTON1 == ON && CAVEBUTTON2 == ON && CAVEBUTTON3 == OFF)
	    {
		scaleX=scaleY=scaleZ=1.0;
	    }
	  cvviewer->myTrans->scaleFactor.setValue(scaleX, scaleY, scaleZ);
	  break;
	  
	default:
	  break;
      }
}


//
// This guy does the draw, and so should do as minimal as necessary
//
void DrawInventorObjs(void)
{
    int ii;

    //
    // doing this new is unnecesary, this should be optimized
    //
    SoSeparator *bigroot = new SoSeparator;

    //
    // Adding all these children is slow, could be optimized better
    //
    bigroot->addChild(cvviewer->pointLight);
    bigroot->addChild(cvviewer->spotLight);
    bigroot->addChild(cvviewer->mode->titleTrans);
    bigroot->addChild(cvviewer->mode->myFont);
    bigroot->addChild(cvviewer->mode->title);
    bigroot->addChild(cvviewer->myTrans);
    DatabaseList *dbl = cvviewer->database;

    for (ii=0; ii<cvviewer->mode->fileMask; ii++)
      {
	  bigroot->addChild(dbl->root);
	  dbl = dbl->next;
      }

    //
    // Get the dimensions of the CAVE window
    //
    XGetWindowAttributes(CAVEXdisplay,CAVEglxWindow,&winAtts);
    SbViewportRegion myViewport(winAtts.width, winAtts.height);

    // building an SoGLRenderAction is slow... but if you globalize it, lighting gets mucked up
    // Jason discovered this -- see his simple version to verify this
//    SoGLRenderAction myRenderAction(myViewport,FALSE);
    SoGLRenderAction myRenderAction(myViewport);

    // since bigroot has a reference count of zero, it will get deleted
    // after this action is applied. Is this what we want? This should be ok,
    // since making root and myTrans children of bigroot, increment their
    // reference count, and bigroot gets deleted after the render action
    // is applied
    myRenderAction.apply(bigroot);
}

